// class_1.sce
// Classification with regression components 
// - known models of components
// -------------------------------------
clc,clear,close,getd(),mode(0)

// simulation
nd=2000;                 // number of data
p=[.2 .5 .3];            // pointer parametr
thS=[1 5 3               // model parametrs
     1 2 8];             //   three clusters: [1 1],[5 2],[3 8]
sd=1.2;                  // standard deviation
for t=1:nd
  c(t)=sum(cumsum(p)<rand(1,1,'u'))+1;            // pointer
  x(:,t)=thS(:,c(t))+sd*eye(2,2)*rand(2,1,'n');   // data
end
nc=size(thS,2);          // number of components

// classification
for t=1:nd
  for j=1:nc
    q(j)=Gauss(x(:,t),thS(:,j),sd^2*eye(2,2)); // proximity
  end
  fc=q/sum(q);           // pointer distribution
  [nill,cp(t)]=max(fc);  // pointer value
  wt(:,t)=fc;
end

// result
Accuracy=sum(c==cp)/nd
