// class_3.sce
// Classification in continuous data space 
// - learning with a teacher
// - recursive
// -------------------------------------
clc,clear,close,getd(),mode(0)
getd c:\functions        // library of functions

// simulation
nL=500;                  // number of data for learning
nT=200;                  // number of data for testing
p=[.2 .5 .3];            // pointer model parameters
thS=[1 5 3               // three clusters: [1 1],[5 2],[3 8]
     1 2 8];             // two variables (comp. pars)
for t=1:(nL+nT)
  y(t)=sum(cumsum(p)<rand(1,1,'u'))+1;          // data y
  x(:,t)=thS(:,y(t))+.8*eye(2,2)*rand(2,1,'n'); // data x
end
[nv,nc]=size(thS);       // numb. of variables and components

// estimation
xL=x(:,1:nL);            // data for 
yT=y(1:nL);              //   learning
m=thS+.5*rand(nv,nc);    // initial parameters
ka=1*ones(1,nc);         // initial counter
S=m.*(ones(nv,1)*ka);    // initial statistics
for t=1:nL
  for j=1:nc
    q(j)=GaussN(xL(:,t),m(:,j),.1); // proximity
  end
  w=q/sum(q);            // weights
  wt(:,t)=w;
  for j=1:nc
    S(:,j)=S(:,j)+w(j)*xL(:,t); // statistics
    ka(j)=ka(j)+w(j);           //   update
    m(:,j)=S(:,j)/ka(j); // parameter estimates
  end
end

// classification
xT=x(:,nL+(1:nT));       // data for
yT=y(nL+(1:nT));         //   testing
for t=1:nT
  for j=1:nc
    q(j)=GaussN(xT(:,t),m(:,j),.1); // proximity
  end
  fy=q/sum(q);           // prediction of the pointer
  [nill,yp(t)]=max(fy);  // value of the pointer
  wt(:,t)=fy;
end

// result
Accuracy=sum(yT==yp)/nT
