// class_4.sce
// Classification in continuous data space 
// - naive Bayes with teacher
// -------------------------------------
clc,clear,close,getd(),mode(0)
getd c:\functions

// simulation
nL=500;             // number of data for learning
nT=200;             // number of data for testing
p=[.2 .5 .3];       // parameters for pointer model
thS=[
1 5 3               // parameters for static Gaussian components 
1 2 8               // -  three clusters, five variables 
2 9 5
8 1 3
1 9 4];
[nv,nc]=size(thS);  // number of variables and comonents
for t=1:(nL+nT)
  y(t)=sum(cumsum(p)<rand(1,1,'u'))+1;       // target (pointer)
  for i=1:nv
    x(i,t)=thS(i,y(t))+.2*rand(1,1,'n');     // variables x
  end
end

// estimation with teacher (known components)
xL=x(:,1:nL);                           // data for 
yT=y(1:nL);                             //   learning
S=.01*ones(nv,nc);                      // initial S
ka=.01*ones(nv,nc);                     // initial kappa
for t=1:nL
  j=yT(t);                              // components from teacher
  for i=1:nv
      S(i,j)=S(i,j)+xL(i,t);            // update of S (sum)
      ka(i,j)=ka(i,j)+1;                //        of ka (count)
      m(i,j)=S(i,j)/ka(i,j);            // parameters
  end
end

// classification
xT=x(:,nL+(1:nT));                      // data for 
yT=y(nL+(1:nT));                        //   testing
for t=1:nT
  qi=1;
  for i=1:nv
    for j=1:nc
      q(j)=GaussN(xT(i,t),m(i,j),.1);   // prox. for i-th variable
    end                                 // - q propto f(xi|y)=[f1(xi|y),f2(xi|y)...]
    qi=qi.*q;                           // product for variables
  end                                   // - fy propto Prod(f(xi|y))
  fy=q/sum(q);                          // normalization
  [nill,yp(t)]=max(fy);                 // argument maxima = classification
  wt(:,t)=fy;
end

// result
Accuracy=sum(yT==yp)/nT                 // num.of positive/num.of all
