// class_5a.sce
// Naive Bayes 
// - normal kernel estimation 
// - two dimensional normal y
// -------------------------------------
exec('SCIHOME/ScIntro.sce',-1); mode(0);

// data
nL=200;                       // number of data for learning
nT=100;                       // number of data for training
th=[2 8                       // model parametrs (const.)
    5 1];
sd{1}=[ 1 .5                  // standard deviation
      -.1  2];
sd{2}=[ 2 -.5
       .2  1];
al=[.6 .4];
for t=1:(nT+nL)
  c(t)=sampCat(al);           // pointer
  y(:,t)=th(:,c(t))+uut(sd{c(t)})*randn(2,1); // data
end

// classification
y1=y(:,find(c(1:nT)==1));                    // y in class 1
y2=y(:,find(c(1:nT)==2));                    // y in class 2
fc(1)=length(y1)/nT;                         // f(c=1)
fc(2)=length(y2)/nT;                         // f(c=2)
for i=1:2
  r1(i)=variance(y1(i,:));                   // var for kernel 1
  r2(i)=variance(y2(i,:));                   // var for kernel 2
end

for t=(1:nL)+nT                              // loop for class.
  q=ones(2,1);
  for i=1:2
    q(1)=q(1)*kerfx(y1(i,:),y(i,t),r1(i));   // proximity  f(c|y1)
    q(2)=q(2)*kerfx(y2(i,:),y(i,t),r2(i));   // proximity  f(c|y1)
  end
  wp=q.*fc;
  w=wp/sum(wp);                              // weight
  wt(:,t)=w;
  cp(t)=amax(w,'r');                         // classif.
end

// results
// Numerical results
tcl=(nT+1):(nT+nL);
ACC=acc(c(tcl),cp(tcl))

// Graphical results
set(scf(),'position',[500 200 800 300]);
// hist and ker of y1    - first variable
[f,s]=histc(y1,20,'b',0);
g=s(2)-s(1);
p=f./(sum(f)*g);
subplot(121)
bar(s,p,'c')
[z,x]=kerf(y1,.1,1);
plot(x,z)
title 'Variable y1 - histogram and kernel'

// hist and ker of y2    - second variable
[f,s]=histc(y2,20,'b',0);
g=s(2)-s(1);
p=f./(sum(f)*g);
subplot(122)
bar(s,p,'c')
[z,x]=kerf(y2,.1,1);
plot(x,z)
title 'Variable y2 - histogram and kernel'
