// class_5b.sce
// Naive Bayes 
// - kernel estimation 
// - two dimensional normal y
// - comparison of various types of kernels
// -------------------------------------
exec('SCIHOME/ScIntro.sce',-1); mode(0);

// data
est=1;    // <-- new estimation 1-yes, 0-no
ik=3;     // <-- select type of kernel
if est
  nd=200;
  th=[2 8
      5 1];
  sd{1}=[ 1 .5
        -.1  2];
  sd{2}=[ 2 -.5
         .2  1];
  al=[.6 .4];
  for t=1:nd
    c(t)=sampCat(al);
    y(:,t)=th(:,c(t))+uut(sd{c(t)})*randn(2,1);
  end
  save yy.dat y c nd
else
  load yy.dat y c nd
  nL=max(size(y));
end

// classification
select ik
  case 0, kr='kerfx';   disp Gauss
  case 1, kr='kerfx1';  disp Epanechnikov
  case 2, kr='kerfx2';  disp Biweight
  case 3, kr='kerfx3';  disp Triweight
  end
  
y1=y(:,find(c==1));                    // y in class 1
y2=y(:,find(c==2));                    // y in class 2
fc(1)=length(y1)/nd;                   // f(c=1)
fc(2)=length(y2)/nd;                   // f(c=2)
for i=1:2
  r1(i)=variance(y1(i,:));  // varince for kernel 1
  r2(i)=variance(y2(i,:));  // varince for kernel 2
end

for t=1:nd                              // loop for class.
  q=ones(2,1);
  for i=1:2
    execstr('q(1)=q(1)*'+kr+'(y1(i,:),y(i,t),r1(i));')   // proximity  f(c|y1)
    execstr('q(2)=q(2)*'+kr+'(y2(i,:),y(i,t),r2(i));')   // proximity  f(c|y1)
  end
  wp=q.*fc;
  w=wp/sum(wp);                         // weight
  wt(:,t)=w;
  cp(t)=amax(w,'r');                    // classif.
end

// results
space
ACC=acc(c,cp)

set(scf(),'position',[500 200 800 300]);
// hist and ker of y1
[f,s]=histc(y1,20,'b',0);
g=s(2)-s(1);
p=f./(sum(f)*g);
subplot(121)
bar(s,p,'c')
[z,x]=kerf(y1,.1,ik);
plot(x,z)

// hist and ker of y2
[f,s]=histc(y2,20,'b',0);
g=s(2)-s(1);
p=f./(sum(f)*g);
subplot(122)
bar(s,p,'c')
[z,x]=kerf(y2,.1,ik);
plot(x,z)
