// class_6b.sce
// Classification in continuous data space 
// - naive Bayes without teacher (= mixture estimation)
// - common pointer to all expl. variables
// - :-D clever manipulation with prox.
// = bonus :-)
// -------------------------------------
clc,clear,close,getd(),mode(0)
getd c:\functions

// simulation
nI=20;
nL=200;
nT=200;
p=[.2 .5 .3];
thS=[
1 5 3               // three clusters, five variables 
1 2 8
2 9 5
8 1 3
1 9 4];
[nv,nc]=size(thS);
for t=1:(nI+nL+nT)
  y(t)=sum(cumsum(p)<rand(1,1,'u'))+1;
  for i=1:nv
    x(i,t)=thS(i,y(t))+.2*rand(1,1,'n');
  end
end

// initiation
xI=x(:,1:nI);
yI=y(1:nI);
ka=1*ones(1,nc);              // counter
for j=1:nc
  s=find(yI==j);
  for i=1:nv
    m(i,j)=mean(xI(i,s));     // component expecatations
    r(i,j)=variance(xI(i,s)); // component variances
    S(i,j)=ka(j)*m(i,j);      // statitstic
  end
end

// estimation
xL=x(:,nI+(1:nL));
yL=y(nI+(1:nL));
for t=1:nL
  for j=1:nc
    for i=1:nv
      [nill,Lq(i,j)]=GaussN(xL(i,t),m(i,j),.1); // proximity
    end
  end
  Sq=sum(Lq,1);
  q=exp(Sq);
  w=q/sum(q);                 // weights
  for j=1:nc
    ka(j)=ka(j)+w(j);
    for i=1:nv
      S(i,j)=S(i,j)+w(j)*xL(i,t);  // update
      m(i,j)=S(i,j)/ka(j);         // estimate
    end
  end
end

// classification
xT=x(:,nI+nL+(1:nT));
yT=y(nI+nL+(1:nT));
v=vals(yT);
fy=fnorm(v(2,:));
for t=1:nT
  for j=1:nc
    for i=1:nv
      [nill,Lq(i,j)]=GaussN(xT(i,t),m(i,j),1); // proximity
    end
  end
  Sq=sum(Lq,1);               // product
  Lfyx=Sq-max(Sq);
  [nill,yp(t)]=max(Lfyx);     // classification
end

// result
Accuracy=sum(yT==yp)/nT
