function [f,sm]=histc(x,n,c,r)
  // histogram of x (continuous)
  // x    data
  // n    number of columns
  // c    color
  // r \in (0,1) - width of the columns
  if argn(2)<4, r=.8; end
  if argn(2)<3, c='b'; end
  if argn(2)<2, n=20; end
  minx=min(x);
  maxx=max(x);
  h=(maxx-minx)/(n);
  s=minx:h:maxx;
  for i=1:n
    f(i)=length(find((x>=s(i))&(x<s(i+1))));
  end
  k=find(x==s(n));
  if ~isempty(k)
    f(n)=f(n)+length(k);
  end
  for i=1:n
    sm(i)=(s(i)+s(i+1))/2;
  end
  if r>0, bar(sm,f,r,c); end
endfunction
