// init_2.sce
// Initialization of categorical model estimation
// - model f(y|x), y=1,2; x=1,2,3
// -------------------------------------
clc, clear, close, mode(0);

// simulation
nd=500;                  // number of data
px=[.3 .5 .2];           // parameter for x-model
py=[.2 .7 .4             // parameter for y-model
    .8 .3 .6];
for t=1:nd
  x(t)=sum(cumsum(px)<rand(1,1,'u'))+1;           // var. x
  y(t)=sum(cumsum(py(:,x(t)))<rand(1,1,'u'))+1;   // var. y
end

// initialization
ka=1;                    // counter
pE=[.3 .7 .2             // initial parametr
    .7 .3 .8];
V=pE*ka;                 // statistics
pEt=pE(1,1);

// estimation
for t=1:nd
  V(y(t),x(t))=V(y(t),x(t))+1;     // statistics
  ka=ka+1;                         //   update
  for j=1:max(x)
    pE(:,j)=V(:,j)/sum(V(:,j));    // estimates
  end
  pEt=[pEt pE(1,1)];
end

// result
set(scf(),'position',[500 200 500 400])
plot(0:nd,pEt)

disp('simulated parameters')
disp(py)
disp('estimated parameters')
disp(pE)
