function z=kerfx1(y,x,v)
  // Gaussian kernel density of data y at x
  // y    data
  // x    argument of the kernel K((x-yi)/h)
  // v    variance of y

  n=length(y);
  h=2.34*sqrt(v)/n^(1/5);
  z=0;
  for t=1:n
    u=(x-y(t))/h;
    if abs(u)<1
      z=z+3*(1-u^2)/4;
    end
  end
  z=z/(h*n);
endfunction
