// pred_2.sce
// Prediction with categorical model
// -------------------------------------
clc,clear,close,mode(0)

// simulation
nd=200;                       // number of data
px=[.3 .2 .3 .2];             // pars for model x
py=[.8 .1 .1 .3               // pars for model y
    .1 .8 .1 .5
    .1 .1 .8 .2];
for t=1:nd
  x(t)=sum(cumsum(px)<rand(1,1,'u'))+1;         // data x
  y(t)=sum(cumsum(py(:,x(t)))<rand(1,1,'u'))+1; // data y
end

select 2       // SELECT type of prediction
case 1              // point prediction
for t=1:nd
  [nill,yp(t)]=max(py(:,x(t)));
end
case 2              // simulated prediction
for t=1:nd
  yp(t)=sum(cumsum(py(:,x(t)))<rand(1,1,'u'))+1;
end
end

// results
set(scf(),'position',[500 200 500 400])
plot(1:nd,y,'o',1:nd,yp,'x')
legend('y','yp');
disp('Accuracy')
disp(sum(y==yp)/nd)
