// pred_5.sce
// PREDICTION WITH DISCRETE MODEL (OFF-LINE)
// Experiments
// Change: - np  = number of steps of prediction
//         - th1 = model parametrs
//         - u   = input signal (effect on estimation)
//         - uncertainty of the system (effect on estimation)
// -------------------------------------------------------------------
exec("ScIntro.sce",-1),mode(0)

nd=50;                             // length of data sample
np=0;                              // length of prediction (np>=1)
th1=[0.98 0.01 0.04 0.97]';        // parameters for simulation (for y=1)
th=[th1 1-th1];                    // all parameters
u=(rand(1,nd)>.3)+1;               // input
y(1)=1;

// SIMULATION
for t=2:nd
  i=2*(u(t)-1)+y(t-1);             // row of the table
  y(t)=(rand(1,1,'u')>th(i,1))+1;  // output generation
end

// PREDICTION
yy=ones(1,nd);                     // fictitious predicted output
for t=2:(nd-np)
  i=2*(u(t)-1)+y(t-1);             // row of the table
  yy=(rand(1,1,'u')>th(i,1))+1;    // prediction generation
  for j=1:np
    i=2*(u(t+j)-1)+yy;             // row of the table
    yy=(rand(1,1,'u')>th(i,1))+1;  // prediction generation
  end
  yp(t+np)=yy;                     // np-step predction
end

// Results
disp(th,' Model parameters'), disp(' ')

s=(np+3):nd;
plot(s,y(s),'.:',s,yp(s),'rx')
set(gcf(),'position',[600 100 800 400])
set(gca(),"data_bounds",[0 nd+1 .9 2.1])
legend('output','prediction');
title(string(np)+'-steps ahead prediction')

Wrong=sum(y(:)~=yp(:)), From=nd
